* Copyright (c) 1990 by AT&T Bell Telephone Laboratories, Incorporated. */
* The C++ Answer Book */
* Tony Hansen */
* All rights reserved. */
/ class process private member functions
/ private:
   // Check if this function is above the low-water mark.
   int mustrecurse()
   { return Stackdir.less(Stackdir.plusone(), t_stackbase); }

   // Used by pause(), wait(), sleep().
   // Save the current state of this process.
   // Returns true when coming back from another process.
   int contextswitch();

   // Used by pause(), wait(), sleep().
   // Find the next class to run
   // and call restore() on it.
   void schedule();

   // Used by schedule().
   // Restore a process to be the current process.
   // It doesn't return but instead comes back
   // through contextswitch().
   // It copies a process' copy of the stack into
   // the stack and longjmp's there.
   void restore();

   // Used by schedule() and wakeup().
   // Move the top process to its place time and
   // priority-wise in the list of runnable processes.
   void shufflerunlist();

   // Remove a process from a given list.
   // Return 0 if not found on the list.
   int rmfromlist(process *, process**);

   // the real version of the destructor
   void Rprocessdest();

   // Reschedule the process for d time units from now.
   void wakeup(unsigned long = 0);
